unit ExtAbout;

{ ************ ExtAbout ***************************************

  Copyright (C) 2011 Bart Broersma

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

 *****************************************************************}


{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, ExtAboutForm, LCLProc;


type

  { TExtAboutDlg }

  TExtAboutDlg = class(TObject)
  private
    FCaption: String;
    FDlg: TExtAboutDlgForm;
    FLicenseWebsiteCaption: String;
    FLicenseWebsiteURL: String;
    FProductName: String;
    FVersion: String;
    FBuildDate: String ;
    FCopyrightStatement: String;
    FLogoResourceName: String;
    FLicenseText: String;
    FWebSiteURL: String;
    FWebSiteCaption: String;
    FLazarusVersion: String;
    FFpcVersion: String;
    FPosition: TPosition;
    FTop: Integer;
    FLeft: Integer;
    procedure SetCaption(const AValue: String);
    procedure SetCopyrightStatement(const AValue: String);
    procedure SetBuildDate(const AValue: String);
    procedure SetFpcVersion(const AValue: String);
    procedure SetLazarusVersion(const AValue: String);
    procedure SetLeft(const AValue: Integer);
    procedure SetLicenseText(const AValue: String);
    procedure SetLicenseWebsiteCaption(const AValue: String);
    procedure SetLicenseWebsiteURL(const AValue: String);
    procedure SetLogoResourceName(const AValue: String);
    procedure SetPosition(const AValue: TPosition);
    procedure SetProductName(const AValue: String);
    procedure SetTop(const AValue: Integer);
    procedure SetVersion(const AValue: String);
    procedure SetWebsiteCaption(const AValue: String);
    procedure SetWebsiteURL(const AValue: String);
  protected
  public
    constructor Create;
    destructor Destroy; override;
    function Execute: TModalResult;
    property Caption: String read FCaption write SetCaption;
    property ProductName: String read FProductName write SetProductName;
    property Version: String read FVersion write SetVersion;
    property BuildDate: String read FBuildDate write SetBuildDate;
    property CopyrightStatement: String read FCopyrightStatement write SetCopyrightStatement;
    property LogoResourceName: String read FLogoResourceName write SetLogoResourceName;
    property LicenseText: String read FLicenseText write SetLicenseText;
    property WebsiteURL: String read FWebsiteURL write SetWebsiteURL;
    property WebsiteCaption: String read FWebsiteCaption write SetWebsiteCaption;
    property LicenseWebsiteURL: String read FLicenseWebsiteURL write SetLicenseWebsiteURL;
    property LicenseWebsiteCaption: String read FLicenseWebsiteCaption write SetLicenseWebsiteCaption;
    property LazarusVersion: String read FLazarusVersion write SetLazarusVersion;
    property FpcVersion: String read FFpcVersion write SetFpcVersion;
    property Top: Integer read FTop write SetTop default -1;
    property Left: Integer read FLeft write SetLeft default -1;
    property Position: TPosition read FPosition write SetPosition default poScreenCenter;
  end;

function ExtAboutDlg: TExtAboutDlg;

implementation

const
  DefaultCopyright = 'Copyright (c) by Bart Broersma & Flying Sheep Inc.';

var TheDlg: TExtAboutDlg;

function ExtAboutDlg: TExtAboutDlg;
begin
  if not Assigned(TheDlg) then
  begin
    TheDlg := TExtAboutDlg.Create;
  end;
  Result := TheDlg;
end;


{ TExtAboutDlg }

procedure TExtAboutDlg.SetProductName(const AValue: String);
begin
  if FProductName=AValue then exit;
  FProductName:=AValue;
end;

procedure TExtAboutDlg.SetTop(const AValue: Integer);
begin
  if FTop=AValue then exit;
  FTop:=AValue;
end;

procedure TExtAboutDlg.SetCopyrightStatement(const AValue: String);
begin
  if FCopyrightStatement=AValue then exit;
  if (AValue <> '') then
    FCopyrightStatement:=AValue
  else
    FCopyrightStatement := DefaultCopyright;
end;

procedure TExtAboutDlg.SetCaption(const AValue: String);
begin
  if FCaption=AValue then exit;
  if AValue = '' then FCaption := 'About'
  else FCaption:=AValue;
end;

procedure TExtAboutDlg.SetBuildDate(const AValue: String);
begin
  if FBuildDate=AValue then exit;
  FBuildDate:=AValue;
end;

procedure TExtAboutDlg.SetFpcVersion(const AValue: String);
begin
  if FFpcVersion=AValue then exit;
  FFpcVersion:=AValue;
end;

procedure TExtAboutDlg.SetLazarusVersion(const AValue: String);
begin
  if FLazarusVersion=AValue then exit;
  FLazarusVersion:=AValue;
end;

procedure TExtAboutDlg.SetLeft(const AValue: Integer);
begin
  if FLeft=AValue then exit;
  FLeft:=AValue;
end;

procedure TExtAboutDlg.SetLicenseText(const AValue: String);
begin
  //debugln('SetLicenseTetx: Length(AValue) = ',dbgs(length(AValue)));
  if FLicenseText=AValue then exit;
  FLicenseText:=AValue;
end;

procedure TExtAboutDlg.SetLicenseWebsiteCaption(const AValue: String);
begin
  //debugln('SetLicenseWebsiteCaption: Avalue = ',Avalue);
  if FLicenseWebsiteCaption=AValue then exit;
  FLicenseWebsiteCaption:=AValue;
end;

procedure TExtAboutDlg.SetLicenseWebsiteURL(const AValue: String);
begin
  //debugln('SetLicenseWebsiteUrl: Avalue = ',Avalue);
  if FLicenseWebsiteURL=AValue then exit;
  FLicenseWebsiteURL:=AValue;
end;

procedure TExtAboutDlg.SetLogoResourceName(const AValue: String);
begin
  if FLogoResourceName=AValue then exit;
  FLogoResourceName:=AValue;
end;

procedure TExtAboutDlg.SetPosition(const AValue: TPosition);
begin
  if FPosition=AValue then exit;
  FPosition:=AValue;
  FLeft := -1;
  FTop := -1;
end;

procedure TExtAboutDlg.SetVersion(const AValue: String);
begin
  if FVersion=AValue then exit;
  FVersion:=AValue;
end;

procedure TExtAboutDlg.SetWebsiteCaption(const AValue: String);
begin
  if FWebsiteCaption=AValue then exit;
  FWebsiteCaption:=AValue;
end;

procedure TExtAboutDlg.SetWebsiteURL(const AValue: String);
begin
  if FWebsiteURL=AValue then exit;
  FWebsiteURL:=AValue;
end;

constructor TExtAboutDlg.Create;
begin
  FDlg := TExtAboutDlgForm.Create(nil);
  FPosition := poScreenCenter;
  FLeft := -1;
  FTop := -1;
  FCopyrightStatement := DefaultCopyright;
end;

destructor TExtAboutDlg.Destroy;
begin
  FDlg.Free;
  inherited Destroy;
end;

function TExtAboutDlg.Execute: TModalResult;
begin
  FDlg.Caption := Caption;
  FDlg.SetVersionInfo(ProductName,Version,BuildDate,LazarusVersion,FpcVersion);
  FDlg.SetCopyrightInfo(CopyrightStatement, WebsiteCaption, WebsiteUrl);
  FDlg.SetLicenseInfo(LicenseText, LicenseWebsiteCaption, LicenseWebsiteUrl);
  if (Left > -1) and (Top > -1) then
  begin
    FDlg.Position := poDesigned;
    FDlg.Top := Top;
    FDlg.Left := Left;
  end
  else
  begin
    FDlg.Position := Position;
  end;
  Result := FDlg.ShowModal;
end;

initialization
  TheDlg := nil;

finalization
  if Assigned(TheDlg) then TheDlg.Free;

end.

